!c Description:
!c   Ǯ, Ǯʬ, Ǯ/٤ʬ η׻
!c   SSL II  INSPL 롼󤫤᤿ǮַѤ
!c
!c Current Code Owner: 
!c   sugiyama@gfd-dennou.org
!c
!c Histry: 
!c   Version    Date          Comment
!c   -------    ----------    --------
!c   1.0        2003-02-05    
!c
!c Copyright (C) SUGIYAMA Ko-ichiro, 2003, All rights reserved

module interface_cp_spl
  interface

     subroutine cp_spl(temp, property, cp, cp_int, cp_dvt_int)  
       use prm_type, only: type_property
       real(8), intent(in)             :: temp       !
       real(8), intent(out), optional  :: cp         !Ǯ
       real(8), intent(out), optional  :: cp_int     !Ǯʬ
       real(8), intent(out), optional  :: cp_dvt_int !Ǯ/٤ʬ
       type(type_property), intent(in) :: property   !ץ饤ַ
     end subroutine cp_spl

  end interface
end module interface_cp_spl



subroutine cp_spl(temp, property, cp, cp_int, cp_dvt_int)  
  use prm_type, only: type_property, type_spl
  use prm_phys, only: temp_ref
  use interface_spl
  use interface_list_output
  use interface_list_get

  implicit none
  real(8), intent(in)             :: temp       !
  real(8), intent(out), optional  :: cp         !Ǯ
  real(8), intent(out), optional  :: cp_int     !Ǯʬ
  real(8), intent(out), optional  :: cp_dvt_int !Ǯ/٤ʬ
  type(type_property), intent(in) :: property   !ץ饤ַ
  
  real(8)                         :: t0       !ʬϲ
  real(8)                         :: t1       !ʬλ
  real(8), allocatable            :: temp_dat(:)
  real(8), allocatable            :: dat_int(:) 
  real(8), allocatable            :: dat_dvt_int(:)
  integer                         :: N        !Ǯǡͤĥǡ
  integer                         :: N_dat    !Ϥ줿٤Ϥǡֹ
  integer                         :: N_ref    !ɸಹ٤Υǡֹ
  logical                         :: sw       
  type(type_spl)                  :: object   !ץ饤ַ


!!!
!!!ǡֹ
!!!
  !ꥹȤ鲹پФ
  call list_output(property%spl, temp=temp_dat, &
       & dat_int=dat_int, dat_dvt_int=dat_dvt_int)
  
  !Τͤĥǡ. 
  N = size(temp_dat, 1)
  
  !Ϥ줿٤Ϥǡֹ
  !ǡβ < ٤ʥǡֹΤǤ礭ֹ
  N_dat = maxloc(temp_dat, 1, temp_dat <= temp)
  
  !٤ǡϰϤ̵ΰ
  if (temp_dat(1) >= temp) N_dat = 1
  if (temp_dat(N) < temp)  N_dat = N
  
  !ɸಹ٤Υǡ
  N_ref = maxloc(temp_dat, 1, temp_dat == temp_ref)
  
  !ʬ֤ν
  t0 = temp_dat(N_dat)
  t1 = temp
  sw = temp_dat(1) <= temp .AND. temp <= temp_dat(N)

  !å
  call list_get(temp_dat(N_dat), property%spl, object)
  
  
!!!
!!!Ǯ. SSL II  spline ֤Ѥ
!!!٤Ϳ줿 cp βϰˤ뤫ɤּۤʤ  
!!!
  if (present(cp)) then 
     call spl(object, t0, t1, sw, var=cp)
  end if
  
!!!
!!!T_i  T ޤǮʬ. SSL II  spline ֤Ѥ
!!!
  if (present(cp_int)) then 
     call spl(object, t0, t1, sw, var_int=cp_int)

     !ɸಹ٤ʬͤѴ. N_dat==N_ref ʤФΤޤ
     if (N_dat < N_ref) then 
        cp_int = - sum(dat_int(N_dat: N_ref-1)) + cp_int
     elseif (N_dat > N_ref) then 
        cp_int = sum(dat_int(N_ref: N_dat-1)) + cp_int
     end if
  end if

!!!
!!!T_i  T ޤ Ǯ/ ʬ. SSL II  spline ֤Ѥ. 
!!!
  if (present(cp_dvt_int)) then 
     call spl(object, t0, t1, sw, var_dvt_int=cp_dvt_int)
     
     !ɸಹ٤ʬͤѴ. N_dat==N_ref ʤФΤޤ
     if (N_dat < N_ref) then 
        cp_dvt_int = - sum(dat_dvt_int(N_dat: N_ref-1)) + cp_dvt_int
     elseif (N_dat > N_ref) then 
        cp_dvt_int = sum(dat_dvt_int(N_ref: N_dat-1)) + cp_dvt_int
     end if
  end if


!!!
!!!夫Ť
!!!
  deallocate(temp_dat, dat_int, dat_dvt_int)

end subroutine cp_spl


